// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// Take the name prefix into account.
#define yylex   parser4_lex

// First part of user declarations.

#line 39 "dhcp4_parser.cc" // lalr1.cc:404

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "dhcp4_parser.h"

// User implementation prologue.

#line 53 "dhcp4_parser.cc" // lalr1.cc:412
// Unqualified %code blocks.
#line 34 "dhcp4_parser.yy" // lalr1.cc:413

#include <dhcp4/parser_context.h>

#line 59 "dhcp4_parser.cc" // lalr1.cc:413


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if PARSER4_DEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !PARSER4_DEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !PARSER4_DEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 14 "dhcp4_parser.yy" // lalr1.cc:479
namespace isc { namespace dhcp {
#line 145 "dhcp4_parser.cc" // lalr1.cc:479

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Dhcp4Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              // Fall through.
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  Dhcp4Parser::Dhcp4Parser (isc::dhcp::Parser4Context& ctx_yyarg)
    :
#if PARSER4_DEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      ctx (ctx_yyarg)
  {}

  Dhcp4Parser::~Dhcp4Parser ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/



  // by_state.
  inline
  Dhcp4Parser::by_state::by_state ()
    : state (empty_state)
  {}

  inline
  Dhcp4Parser::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
  Dhcp4Parser::by_state::clear ()
  {
    state = empty_state;
  }

  inline
  void
  Dhcp4Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  inline
  Dhcp4Parser::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
  Dhcp4Parser::symbol_number_type
  Dhcp4Parser::by_state::type_get () const
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  inline
  Dhcp4Parser::stack_symbol_type::stack_symbol_type ()
  {}


  inline
  Dhcp4Parser::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
      switch (that.type_get ())
    {
      case 162: // value
      case 166: // map_value
      case 204: // socket_type
      case 214: // db_type
      case 291: // hr_mode
      case 434: // ncr_protocol_value
      case 442: // replace_client_name_value
        value.move< ElementPtr > (that.value);
        break;

      case 147: // "boolean"
        value.move< bool > (that.value);
        break;

      case 146: // "floating point"
        value.move< double > (that.value);
        break;

      case 145: // "integer"
        value.move< int64_t > (that.value);
        break;

      case 144: // "constant string"
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    // that is emptied.
    that.type = empty_symbol;
  }

  inline
  Dhcp4Parser::stack_symbol_type&
  Dhcp4Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
      switch (that.type_get ())
    {
      case 162: // value
      case 166: // map_value
      case 204: // socket_type
      case 214: // db_type
      case 291: // hr_mode
      case 434: // ncr_protocol_value
      case 442: // replace_client_name_value
        value.copy< ElementPtr > (that.value);
        break;

      case 147: // "boolean"
        value.copy< bool > (that.value);
        break;

      case 146: // "floating point"
        value.copy< double > (that.value);
        break;

      case 145: // "integer"
        value.copy< int64_t > (that.value);
        break;

      case 144: // "constant string"
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
  Dhcp4Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if PARSER4_DEBUG
  template <typename Base>
  void
  Dhcp4Parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    switch (yytype)
    {
            case 144: // "constant string"

#line 221 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< std::string > (); }
#line 364 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 145: // "integer"

#line 221 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< int64_t > (); }
#line 371 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 146: // "floating point"

#line 221 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< double > (); }
#line 378 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 147: // "boolean"

#line 221 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< bool > (); }
#line 385 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 162: // value

#line 221 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 392 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 166: // map_value

#line 221 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 399 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 204: // socket_type

#line 221 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 406 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 214: // db_type

#line 221 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 413 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 291: // hr_mode

#line 221 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 420 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 434: // ncr_protocol_value

#line 221 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 427 "dhcp4_parser.cc" // lalr1.cc:636
        break;

      case 442: // replace_client_name_value

#line 221 "dhcp4_parser.yy" // lalr1.cc:636
        { yyoutput << yysym.value.template as< ElementPtr > (); }
#line 434 "dhcp4_parser.cc" // lalr1.cc:636
        break;


      default:
        break;
    }
    yyo << ')';
  }
#endif

  inline
  void
  Dhcp4Parser::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
  Dhcp4Parser::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
  Dhcp4Parser::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if PARSER4_DEBUG
  std::ostream&
  Dhcp4Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Dhcp4Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Dhcp4Parser::debug_level_type
  Dhcp4Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Dhcp4Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // PARSER4_DEBUG

  inline Dhcp4Parser::state_type
  Dhcp4Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  inline bool
  Dhcp4Parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  Dhcp4Parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Dhcp4Parser::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            symbol_type yylookahead (yylex (ctx));
            yyla.move (yylookahead);
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
        switch (yyr1_[yyn])
    {
      case 162: // value
      case 166: // map_value
      case 204: // socket_type
      case 214: // db_type
      case 291: // hr_mode
      case 434: // ncr_protocol_value
      case 442: // replace_client_name_value
        yylhs.value.build< ElementPtr > ();
        break;

      case 147: // "boolean"
        yylhs.value.build< bool > ();
        break;

      case 146: // "floating point"
        yylhs.value.build< double > ();
        break;

      case 145: // "integer"
        yylhs.value.build< int64_t > ();
        break;

      case 144: // "constant string"
        yylhs.value.build< std::string > ();
        break;

      default:
        break;
    }


      // Compute the default @$.
      {
        slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, slice, yylen);
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
      try
        {
          switch (yyn)
            {
  case 2:
#line 230 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.NO_KEYWORD; }
#line 680 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 4:
#line 231 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.CONFIG; }
#line 686 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 6:
#line 232 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.DHCP4; }
#line 692 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 8:
#line 233 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.INTERFACES_CONFIG; }
#line 698 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 10:
#line 234 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.SUBNET4; }
#line 704 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 12:
#line 235 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.POOLS; }
#line 710 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 14:
#line 236 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.RESERVATIONS; }
#line 716 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 16:
#line 237 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.DHCP4; }
#line 722 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 18:
#line 238 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.OPTION_DEF; }
#line 728 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 20:
#line 239 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.OPTION_DATA; }
#line 734 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 22:
#line 240 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.HOOKS_LIBRARIES; }
#line 740 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 24:
#line 241 "dhcp4_parser.yy" // lalr1.cc:859
    { ctx.ctx_ = ctx.DHCP_DDNS; }
#line 746 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 26:
#line 249 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location))); }
#line 752 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 27:
#line 250 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new DoubleElement(yystack_[0].value.as< double > (), ctx.loc2pos(yystack_[0].location))); }
#line 758 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 28:
#line 251 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location))); }
#line 764 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 29:
#line 252 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location))); }
#line 770 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 30:
#line 253 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new NullElement(ctx.loc2pos(yystack_[0].location))); }
#line 776 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 31:
#line 254 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ctx.stack_.back(); ctx.stack_.pop_back(); }
#line 782 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 32:
#line 255 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ctx.stack_.back(); ctx.stack_.pop_back(); }
#line 788 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 33:
#line 258 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Push back the JSON value on the stack
    ctx.stack_.push_back(yystack_[0].value.as< ElementPtr > ());
}
#line 797 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 34:
#line 263 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // This code is executed when we're about to start parsing
    // the content of the map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 808 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 35:
#line 268 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // map parsing completed. If we ever want to do any wrap up
    // (maybe some sanity checking), this would be the best place
    // for it.
}
#line 818 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 36:
#line 274 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ctx.stack_.back(); ctx.stack_.pop_back(); }
#line 824 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 39:
#line 281 "dhcp4_parser.yy" // lalr1.cc:859
    {
                  // map containing a single entry
                  ctx.stack_.back()->set(yystack_[2].value.as< std::string > (), yystack_[0].value.as< ElementPtr > ());
                  }
#line 833 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 40:
#line 285 "dhcp4_parser.yy" // lalr1.cc:859
    {
                  // map consisting of a shorter map followed by
                  // comma and string:value
                  ctx.stack_.back()->set(yystack_[2].value.as< std::string > (), yystack_[0].value.as< ElementPtr > ());
                  }
#line 843 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 41:
#line 292 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(l);
}
#line 852 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 42:
#line 295 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // list parsing complete. Put any sanity checking here
}
#line 860 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 45:
#line 303 "dhcp4_parser.yy" // lalr1.cc:859
    {
                  // List consisting of a single element.
                  ctx.stack_.back()->add(yystack_[0].value.as< ElementPtr > ());
                  }
#line 869 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 46:
#line 307 "dhcp4_parser.yy" // lalr1.cc:859
    {
                  // List ending with , and a value.
                  ctx.stack_.back()->add(yystack_[0].value.as< ElementPtr > ());
                  }
#line 878 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 47:
#line 314 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // List parsing about to start
}
#line 886 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 48:
#line 316 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // list parsing complete. Put any sanity checking here
    //ctx.stack_.pop_back();
}
#line 895 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 51:
#line 325 "dhcp4_parser.yy" // lalr1.cc:859
    {
                          ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
                          ctx.stack_.back()->add(s);
                          }
#line 904 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 52:
#line 329 "dhcp4_parser.yy" // lalr1.cc:859
    {
                          ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
                          ctx.stack_.back()->add(s);
                          }
#line 913 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 53:
#line 340 "dhcp4_parser.yy" // lalr1.cc:859
    {
    const std::string& where = ctx.contextName();
    const std::string& keyword = yystack_[1].value.as< std::string > ();
    error(yystack_[1].location,
          "got unexpected keyword \"" + keyword + "\" in " + where + " map.");
}
#line 924 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 54:
#line 350 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // This code is executed when we're about to start parsing
    // the content of the map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 935 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 55:
#line 355 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // map parsing completed. If we ever want to do any wrap up
    // (maybe some sanity checking), this would be the best place
    // for it.

    // Dhcp4 is required
    ctx.require("Dhcp4", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
}
#line 948 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 64:
#line 379 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // This code is executed when we're about to start parsing
    // the content of the map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("Dhcp4", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.DHCP4);
}
#line 961 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 65:
#line 386 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // No global parameter is required
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 971 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 66:
#line 394 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the Dhcp4 map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 981 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 67:
#line 398 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // No global parameter is required
    // parsing completed
}
#line 990 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 92:
#line 433 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("valid-lifetime", prf);
}
#line 999 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 93:
#line 438 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("renew-timer", prf);
}
#line 1008 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 94:
#line 443 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("rebind-timer", prf);
}
#line 1017 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 95:
#line 448 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr dpp(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("decline-probation-period", dpp);
}
#line 1026 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 96:
#line 453 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr echo(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("echo-client-id", echo);
}
#line 1035 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 97:
#line 458 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr match(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("match-client-id", match);
}
#line 1044 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 98:
#line 464 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("interfaces-config", i);
    ctx.stack_.push_back(i);
    ctx.enter(ctx.INTERFACES_CONFIG);
}
#line 1055 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 99:
#line 469 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // No interfaces config param is required
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1065 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 105:
#line 484 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the interfaces-config map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 1075 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 106:
#line 488 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // No interfaces config param is required
    // parsing completed
}
#line 1084 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 107:
#line 493 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("interfaces", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1095 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 108:
#line 498 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1104 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 109:
#line 503 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.DHCP_SOCKET_TYPE);
}
#line 1112 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 110:
#line 505 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("dhcp-socket-type", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 1121 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 111:
#line 510 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("raw", ctx.loc2pos(yystack_[0].location))); }
#line 1127 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 112:
#line 511 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("udp", ctx.loc2pos(yystack_[0].location))); }
#line 1133 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 113:
#line 514 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("re-detect", b);
}
#line 1142 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 114:
#line 520 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("lease-database", i);
    ctx.stack_.push_back(i);
    ctx.enter(ctx.LEASE_DATABASE);
}
#line 1153 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 115:
#line 525 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // The type parameter is required
    ctx.require("type", ctx.loc2pos(yystack_[2].location), ctx.loc2pos(yystack_[0].location));
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1164 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 116:
#line 532 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hosts-database", i);
    ctx.stack_.push_back(i);
    ctx.enter(ctx.HOSTS_DATABASE);
}
#line 1175 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 117:
#line 537 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // The type parameter is required
    ctx.require("type", ctx.loc2pos(yystack_[2].location), ctx.loc2pos(yystack_[0].location));
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1186 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 133:
#line 563 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.DATABASE_TYPE);
}
#line 1194 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 134:
#line 565 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("type", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 1203 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 135:
#line 570 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("memfile", ctx.loc2pos(yystack_[0].location))); }
#line 1209 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 136:
#line 571 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("mysql", ctx.loc2pos(yystack_[0].location))); }
#line 1215 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 137:
#line 572 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("postgresql", ctx.loc2pos(yystack_[0].location))); }
#line 1221 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 138:
#line 573 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("cql", ctx.loc2pos(yystack_[0].location))); }
#line 1227 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 139:
#line 574 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("radius", ctx.loc2pos(yystack_[0].location))); }
#line 1233 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 140:
#line 577 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1241 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 141:
#line 579 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr user(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("user", user);
    ctx.leave();
}
#line 1251 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 142:
#line 585 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1259 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 143:
#line 587 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr pwd(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("password", pwd);
    ctx.leave();
}
#line 1269 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 144:
#line 593 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1277 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 145:
#line 595 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr h(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("host", h);
    ctx.leave();
}
#line 1287 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 146:
#line 601 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr p(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("port", p);
}
#line 1296 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 147:
#line 606 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1304 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 148:
#line 608 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr name(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("name", name);
    ctx.leave();
}
#line 1314 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 149:
#line 614 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr n(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("persist", n);
}
#line 1323 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 150:
#line 619 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr n(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("lfc-interval", n);
}
#line 1332 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 151:
#line 624 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr n(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("readonly", n);
}
#line 1341 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 152:
#line 629 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr n(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("connect-timeout", n);
}
#line 1350 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 153:
#line 634 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1358 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 154:
#line 636 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr cp(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("contact-points", cp);
    ctx.leave();
}
#line 1368 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 155:
#line 642 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1376 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 156:
#line 644 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr ks(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("keyspace", ks);
    ctx.leave();
}
#line 1386 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 157:
#line 651 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("host-reservation-identifiers", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.HOST_RESERVATION_IDENTIFIERS);
}
#line 1397 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 158:
#line 656 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1406 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 166:
#line 672 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr duid(new StringElement("duid", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(duid);
}
#line 1415 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 167:
#line 677 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr hwaddr(new StringElement("hw-address", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(hwaddr);
}
#line 1424 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 168:
#line 682 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr circuit(new StringElement("circuit-id", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(circuit);
}
#line 1433 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 169:
#line 687 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr client(new StringElement("client-id", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(client);
}
#line 1442 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 170:
#line 692 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr flex_id(new StringElement("flex-id", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(flex_id);
}
#line 1451 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 171:
#line 697 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hooks-libraries", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.HOOKS_LIBRARIES);
}
#line 1462 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 172:
#line 702 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1471 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 177:
#line 715 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 1481 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 178:
#line 719 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // The library hooks parameter is required
    ctx.require("library", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
    ctx.stack_.pop_back();
}
#line 1491 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 179:
#line 725 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the hooks-libraries list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 1501 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 180:
#line 729 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // The library hooks parameter is required
    ctx.require("library", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
    // parsing completed
}
#line 1511 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 186:
#line 744 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1519 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 187:
#line 746 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr lib(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("library", lib);
    ctx.leave();
}
#line 1529 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 188:
#line 752 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1537 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 189:
#line 754 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("parameters", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 1546 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 190:
#line 760 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("expired-leases-processing", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.EXPIRED_LEASES_PROCESSING);
}
#line 1557 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 191:
#line 765 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // No expired lease parameter is required
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1567 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 200:
#line 783 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("reclaim-timer-wait-time", value);
}
#line 1576 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 201:
#line 788 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("flush-reclaimed-timer-wait-time", value);
}
#line 1585 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 202:
#line 793 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hold-reclaimed-time", value);
}
#line 1594 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 203:
#line 798 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("max-reclaim-leases", value);
}
#line 1603 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 204:
#line 803 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("max-reclaim-time", value);
}
#line 1612 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 205:
#line 808 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr value(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("unwarned-reclaim-cycles", value);
}
#line 1621 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 206:
#line 816 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("subnet4", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.SUBNET4);
}
#line 1632 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 207:
#line 821 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1641 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 212:
#line 841 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 1651 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 213:
#line 845 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Once we reached this place, the subnet parsing is now complete.
    // If we want to, we can implement default values here.
    // In particular we can do things like this:
    // if (!ctx.stack_.back()->get("interface")) {
    //     ctx.stack_.back()->set("interface", StringElement("loopback"));
    // }
    //
    // We can also stack up one level (Dhcp4) and copy over whatever
    // global parameters we want to:
    // if (!ctx.stack_.back()->get("renew-timer")) {
    //     ElementPtr renew = ctx_stack_[...].get("renew-timer");
    //     if (renew) {
    //         ctx.stack_.back()->set("renew-timer", renew);
    //     }
    // }

    // The subnet subnet4 parameter is required
    ctx.require("subnet", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
    ctx.stack_.pop_back();
}
#line 1677 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 214:
#line 867 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the subnet4 list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 1687 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 215:
#line 871 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // The subnet subnet4 parameter is required
    ctx.require("subnet", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
    // parsing completed
}
#line 1697 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 239:
#line 906 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1705 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 240:
#line 908 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr subnet(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("subnet", subnet);
    ctx.leave();
}
#line 1715 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 241:
#line 914 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1723 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 242:
#line 916 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr iface(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("4o6-interface", iface);
    ctx.leave();
}
#line 1733 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 243:
#line 922 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1741 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 244:
#line 924 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr iface(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("4o6-interface-id", iface);
    ctx.leave();
}
#line 1751 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 245:
#line 930 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1759 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 246:
#line 932 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr iface(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("4o6-subnet", iface);
    ctx.leave();
}
#line 1769 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 247:
#line 938 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1777 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 248:
#line 940 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr iface(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("interface", iface);
    ctx.leave();
}
#line 1787 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 249:
#line 946 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 1795 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 250:
#line 948 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr iface(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("interface-id", iface);
    ctx.leave();
}
#line 1805 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 251:
#line 954 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.CLIENT_CLASS);
}
#line 1813 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 252:
#line 956 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr cls(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("client-class", cls);
    ctx.leave();
}
#line 1823 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 253:
#line 962 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.RESERVATION_MODE);
}
#line 1831 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 254:
#line 964 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("reservation-mode", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 1840 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 255:
#line 969 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("disabled", ctx.loc2pos(yystack_[0].location))); }
#line 1846 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 256:
#line 970 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("out-of-pool", ctx.loc2pos(yystack_[0].location))); }
#line 1852 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 257:
#line 971 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("all", ctx.loc2pos(yystack_[0].location))); }
#line 1858 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 258:
#line 974 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr id(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("id", id);
}
#line 1867 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 259:
#line 979 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr rc(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("rapid-commit", rc);
}
#line 1876 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 260:
#line 986 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("shared-networks", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.SHARED_NETWORK);
}
#line 1887 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 261:
#line 991 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1896 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 266:
#line 1006 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 1906 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 267:
#line 1010 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 1914 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 283:
#line 1037 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("option-def", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.OPTION_DEF);
}
#line 1925 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 284:
#line 1042 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 1934 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 285:
#line 1050 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 1943 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 286:
#line 1053 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // parsing completed
}
#line 1951 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 291:
#line 1069 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 1961 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 292:
#line 1073 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // The name, code and type option def parameters are required.
    ctx.require("name", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
    ctx.require("code", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
    ctx.require("type", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
    ctx.stack_.pop_back();
}
#line 1973 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 293:
#line 1084 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the option-def list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 1983 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 294:
#line 1088 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // The name, code and type option def parameters are required.
    ctx.require("name", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
    ctx.require("code", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
    ctx.require("type", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
    // parsing completed
}
#line 1995 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 308:
#line 1118 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr code(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("code", code);
}
#line 2004 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 310:
#line 1125 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2012 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 311:
#line 1127 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr prf(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("type", prf);
    ctx.leave();
}
#line 2022 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 312:
#line 1133 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2030 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 313:
#line 1135 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr rtypes(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("record-types", rtypes);
    ctx.leave();
}
#line 2040 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 314:
#line 1141 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2048 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 315:
#line 1143 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr space(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("space", space);
    ctx.leave();
}
#line 2058 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 317:
#line 1151 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2066 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 318:
#line 1153 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr encap(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("encapsulate", encap);
    ctx.leave();
}
#line 2076 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 319:
#line 1159 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr array(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("array", array);
}
#line 2085 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 320:
#line 1168 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("option-data", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.OPTION_DATA);
}
#line 2096 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 321:
#line 1173 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2105 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 326:
#line 1192 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 2115 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 327:
#line 1196 "dhcp4_parser.yy" // lalr1.cc:859
    {
    /// @todo: the code or name parameters are required.
    ctx.stack_.pop_back();
}
#line 2124 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 328:
#line 1204 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the option-data list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 2134 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 329:
#line 1208 "dhcp4_parser.yy" // lalr1.cc:859
    {
    /// @todo: the code or name parameters are required.
    // parsing completed
}
#line 2143 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 342:
#line 1239 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2151 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 343:
#line 1241 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr data(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("data", data);
    ctx.leave();
}
#line 2161 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 346:
#line 1251 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr space(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("csv-format", space);
}
#line 2170 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 347:
#line 1256 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr persist(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("always-send", persist);
}
#line 2179 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 348:
#line 1264 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("pools", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.POOLS);
}
#line 2190 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 349:
#line 1269 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2199 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 354:
#line 1284 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 2209 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 355:
#line 1288 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // The pool parameter is required.
    ctx.require("pool", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
    ctx.stack_.pop_back();
}
#line 2219 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 356:
#line 1294 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the pool list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 2229 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 357:
#line 1298 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // The pool parameter is required.
    ctx.require("pool", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
    // parsing completed
}
#line 2239 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 364:
#line 1314 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2247 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 365:
#line 1316 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr pool(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("pool", pool);
    ctx.leave();
}
#line 2257 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 366:
#line 1322 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2265 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 367:
#line 1324 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("user-context", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2274 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 368:
#line 1332 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("reservations", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.RESERVATIONS);
}
#line 2285 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 369:
#line 1337 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2294 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 374:
#line 1350 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 2304 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 375:
#line 1354 "dhcp4_parser.yy" // lalr1.cc:859
    {
    /// @todo: an identifier parameter is required.
    ctx.stack_.pop_back();
}
#line 2313 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 376:
#line 1359 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the reservations list entry map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 2323 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 377:
#line 1363 "dhcp4_parser.yy" // lalr1.cc:859
    {
    /// @todo: an identifier parameter is required.
    // parsing completed
}
#line 2332 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 395:
#line 1392 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2340 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 396:
#line 1394 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr next_server(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("next-server", next_server);
    ctx.leave();
}
#line 2350 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 397:
#line 1400 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2358 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 398:
#line 1402 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr srv(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("server-hostname", srv);
    ctx.leave();
}
#line 2368 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 399:
#line 1408 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2376 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 400:
#line 1410 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr bootfile(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("boot-file-name", bootfile);
    ctx.leave();
}
#line 2386 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 401:
#line 1416 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2394 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 402:
#line 1418 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr addr(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("ip-address", addr);
    ctx.leave();
}
#line 2404 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 403:
#line 1424 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2412 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 404:
#line 1426 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr d(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("duid", d);
    ctx.leave();
}
#line 2422 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 405:
#line 1432 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2430 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 406:
#line 1434 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr hw(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hw-address", hw);
    ctx.leave();
}
#line 2440 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 407:
#line 1440 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2448 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 408:
#line 1442 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr hw(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("client-id", hw);
    ctx.leave();
}
#line 2458 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 409:
#line 1448 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2466 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 410:
#line 1450 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr hw(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("circuit-id", hw);
    ctx.leave();
}
#line 2476 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 411:
#line 1456 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2484 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 412:
#line 1458 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr hw(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("flex-id", hw);
    ctx.leave();
}
#line 2494 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 413:
#line 1464 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2502 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 414:
#line 1466 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr host(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("hostname", host);
    ctx.leave();
}
#line 2512 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 415:
#line 1472 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr c(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("client-classes", c);
    ctx.stack_.push_back(c);
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2523 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 416:
#line 1477 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2532 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 417:
#line 1485 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("relay", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.RELAY);
}
#line 2543 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 418:
#line 1490 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2552 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 419:
#line 1495 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2560 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 420:
#line 1497 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr ip(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("ip-address", ip);
    ctx.leave();
}
#line 2570 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 421:
#line 1506 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("client-classes", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.CLIENT_CLASSES);
}
#line 2581 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 422:
#line 1511 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2590 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 425:
#line 1520 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 2600 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 426:
#line 1524 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // The name client class parameter is required.
    ctx.require("name", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
    ctx.stack_.pop_back();
}
#line 2610 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 439:
#line 1549 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2618 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 440:
#line 1551 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr test(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("test", test);
    ctx.leave();
}
#line 2628 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 441:
#line 1561 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr time(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("dhcp4o6-port", time);
}
#line 2637 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 442:
#line 1568 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("control-socket", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.CONTROL_SOCKET);
}
#line 2648 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 443:
#line 1573 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2657 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 448:
#line 1586 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2665 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 449:
#line 1588 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr stype(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("socket-type", stype);
    ctx.leave();
}
#line 2675 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 450:
#line 1594 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2683 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 451:
#line 1596 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr name(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("socket-name", name);
    ctx.leave();
}
#line 2693 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 452:
#line 1604 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("dhcp-ddns", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.DHCP_DDNS);
}
#line 2704 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 453:
#line 1609 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // The enable updates DHCP DDNS parameter is required.
    ctx.require("enable-updates", ctx.loc2pos(yystack_[2].location), ctx.loc2pos(yystack_[0].location));
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 2715 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 454:
#line 1616 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // Parse the dhcp-ddns map
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.push_back(m);
}
#line 2725 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 455:
#line 1620 "dhcp4_parser.yy" // lalr1.cc:859
    {
    // The enable updates DHCP DDNS parameter is required.
    ctx.require("enable-updates", ctx.loc2pos(yystack_[3].location), ctx.loc2pos(yystack_[0].location));
    // parsing completed
}
#line 2735 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 473:
#line 1647 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("enable-updates", b);
}
#line 2744 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 474:
#line 1652 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2752 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 475:
#line 1654 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("qualifying-suffix", s);
    ctx.leave();
}
#line 2762 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 476:
#line 1660 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2770 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 477:
#line 1662 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("server-ip", s);
    ctx.leave();
}
#line 2780 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 478:
#line 1668 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("server-port", i);
}
#line 2789 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 479:
#line 1673 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2797 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 480:
#line 1675 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("sender-ip", s);
    ctx.leave();
}
#line 2807 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 481:
#line 1681 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("sender-port", i);
}
#line 2816 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 482:
#line 1686 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr i(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("max-queue-size", i);
}
#line 2825 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 483:
#line 1691 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NCR_PROTOCOL);
}
#line 2833 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 484:
#line 1693 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("ncr-protocol", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2842 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 485:
#line 1699 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("UDP", ctx.loc2pos(yystack_[0].location))); }
#line 2848 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 486:
#line 1700 "dhcp4_parser.yy" // lalr1.cc:859
    { yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("TCP", ctx.loc2pos(yystack_[0].location))); }
#line 2854 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 487:
#line 1703 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NCR_FORMAT);
}
#line 2862 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 488:
#line 1705 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr json(new StringElement("JSON", ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("ncr-format", json);
    ctx.leave();
}
#line 2872 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 489:
#line 1711 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("always-include-fqdn", b);
}
#line 2881 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 490:
#line 1716 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("override-no-update", b);
}
#line 2890 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 491:
#line 1721 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr b(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("override-client-update", b);
}
#line 2899 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 492:
#line 1726 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.REPLACE_CLIENT_NAME);
}
#line 2907 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 493:
#line 1728 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("replace-client-name", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2916 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 494:
#line 1734 "dhcp4_parser.yy" // lalr1.cc:859
    {
      yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("when-present", ctx.loc2pos(yystack_[0].location))); 
      }
#line 2924 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 495:
#line 1737 "dhcp4_parser.yy" // lalr1.cc:859
    {
      yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("never", ctx.loc2pos(yystack_[0].location)));
      }
#line 2932 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 496:
#line 1740 "dhcp4_parser.yy" // lalr1.cc:859
    {
      yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("always", ctx.loc2pos(yystack_[0].location)));
      }
#line 2940 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 497:
#line 1743 "dhcp4_parser.yy" // lalr1.cc:859
    {
      yylhs.value.as< ElementPtr > () = ElementPtr(new StringElement("when-not-present", ctx.loc2pos(yystack_[0].location)));
      }
#line 2948 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 498:
#line 1746 "dhcp4_parser.yy" // lalr1.cc:859
    {
      error(yystack_[0].location, "boolean values for the replace-client-name are "
                "no longer supported");
      }
#line 2957 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 499:
#line 1752 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2965 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 500:
#line 1754 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr s(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("generated-prefix", s);
    ctx.leave();
}
#line 2975 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 501:
#line 1762 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 2983 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 502:
#line 1764 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("Dhcp6", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 2992 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 503:
#line 1769 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 3000 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 504:
#line 1771 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("DhcpDdns", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 3009 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 505:
#line 1776 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 3017 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 506:
#line 1778 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.back()->set("Control-agent", yystack_[0].value.as< ElementPtr > ());
    ctx.leave();
}
#line 3026 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 507:
#line 1788 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("Logging", m);
    ctx.stack_.push_back(m);
    ctx.enter(ctx.LOGGING);
}
#line 3037 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 508:
#line 1793 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 3046 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 512:
#line 1810 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("loggers", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.LOGGERS);
}
#line 3057 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 513:
#line 1815 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 3066 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 516:
#line 1827 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(l);
    ctx.stack_.push_back(l);
}
#line 3076 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 517:
#line 1831 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 3084 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 525:
#line 1846 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr dl(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("debuglevel", dl);
}
#line 3093 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 526:
#line 1851 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 3101 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 527:
#line 1853 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr sev(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("severity", sev);
    ctx.leave();
}
#line 3111 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 528:
#line 1859 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr l(new ListElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("output_options", l);
    ctx.stack_.push_back(l);
    ctx.enter(ctx.OUTPUT_OPTIONS);
}
#line 3122 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 529:
#line 1864 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
    ctx.leave();
}
#line 3131 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 532:
#line 1873 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr m(new MapElement(ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->add(m);
    ctx.stack_.push_back(m);
}
#line 3141 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 533:
#line 1877 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.stack_.pop_back();
}
#line 3149 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 540:
#line 1891 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ctx.enter(ctx.NO_KEYWORD);
}
#line 3157 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 541:
#line 1893 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr sev(new StringElement(yystack_[0].value.as< std::string > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("output", sev);
    ctx.leave();
}
#line 3167 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 542:
#line 1899 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr flush(new BoolElement(yystack_[0].value.as< bool > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("flush", flush);
}
#line 3176 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 543:
#line 1904 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr maxsize(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("maxsize", maxsize);
}
#line 3185 "dhcp4_parser.cc" // lalr1.cc:859
    break;

  case 544:
#line 1909 "dhcp4_parser.yy" // lalr1.cc:859
    {
    ElementPtr maxver(new IntElement(yystack_[0].value.as< int64_t > (), ctx.loc2pos(yystack_[0].location)));
    ctx.stack_.back()->set("maxver", maxver);
}
#line 3194 "dhcp4_parser.cc" // lalr1.cc:859
    break;


#line 3198 "dhcp4_parser.cc" // lalr1.cc:859
            default:
              break;
            }
        }
      catch (const syntax_error& yyexc)
        {
          error (yyexc);
          YYERROR;
        }
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, yylhs);
    }
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
  Dhcp4Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
  Dhcp4Parser::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (!yyla.empty ())
      {
        int yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short int Dhcp4Parser::yypact_ninf_ = -688;

  const signed char Dhcp4Parser::yytable_ninf_ = -1;

  const short int
  Dhcp4Parser::yypact_[] =
  {
     210,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,    48,    18,    95,   103,   129,   130,   141,
     147,   154,   162,   173,   182,   193,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
      18,    37,     9,   175,   268,    22,   -16,    34,   153,    93,
      41,   -14,   221,  -688,   204,   209,   218,   213,   226,  -688,
    -688,  -688,  -688,  -688,   269,  -688,    44,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,   278,   281,  -688,  -688,  -688,   282,
     287,   288,   289,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,   290,  -688,  -688,  -688,    62,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
     291,    73,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,   292,   295,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,   144,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,   152,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,   232,   297,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,   298,  -688,  -688,
     303,  -688,  -688,  -688,   305,  -688,  -688,   302,   309,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
     311,   313,  -688,  -688,  -688,  -688,   327,   333,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,   164,  -688,
    -688,  -688,   334,  -688,  -688,   335,  -688,   350,   351,  -688,
    -688,   352,   356,   357,  -688,  -688,  -688,   165,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,    18,    18,  -688,   220,   358,   362,
     363,   364,   365,  -688,     9,  -688,   366,   229,   230,   367,
     368,   369,   233,   234,   237,   238,   370,   371,   376,   377,
     380,   381,   382,   383,   243,   385,   386,   175,  -688,   387,
     388,   246,   268,  -688,    30,   390,   391,   392,   393,   394,
     395,   396,   397,   257,   259,   399,   400,   401,   403,    22,
    -688,   404,   -16,  -688,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,  -688,    34,  -688,   415,   416,   276,
     418,   419,   420,   279,  -688,    93,   421,   280,   283,  -688,
      41,   424,   425,   -12,  -688,   284,   428,   429,   293,   430,
     294,   296,   431,   432,   300,   301,   304,   433,   438,   221,
    -688,  -688,  -688,   439,   437,   442,    18,    18,    18,  -688,
     443,  -688,  -688,   310,   448,   449,  -688,  -688,  -688,  -688,
     453,   454,   455,   456,   457,   460,   461,   462,  -688,   463,
     465,  -688,   468,    21,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,   459,   471,  -688,  -688,  -688,   324,   331,
     332,   472,   473,   337,   339,   340,  -688,  -688,   197,   341,
     474,   479,  -688,   343,  -688,   345,   346,   468,   347,   348,
     349,   353,   354,   355,   359,  -688,   360,   361,  -688,   372,
     373,   374,  -688,  -688,   375,  -688,  -688,  -688,   378,    18,
    -688,  -688,   379,   384,  -688,   389,  -688,  -688,    17,   398,
    -688,  -688,  -688,    40,   402,  -688,    18,   175,   417,  -688,
    -688,  -688,   268,  -688,   219,   219,   487,   488,   489,   493,
      42,    31,   494,   -33,    28,   221,  -688,  -688,  -688,  -688,
    -688,   498,  -688,    30,  -688,  -688,  -688,   499,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,   500,   426,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,   167,  -688,   168,  -688,  -688,   174,
    -688,  -688,  -688,  -688,   504,   505,   507,   508,   510,  -688,
    -688,  -688,   176,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,   180,  -688,   509,   475,
    -688,  -688,   514,   518,  -688,  -688,   519,   521,  -688,  -688,
     520,   524,  -688,  -688,  -688,  -688,  -688,  -688,   196,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,   235,  -688,   523,   527,
    -688,   528,   530,   531,   532,   533,   535,   187,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,   188,  -688,  -688,
    -688,   205,   422,   423,  -688,  -688,   525,   537,  -688,  -688,
     536,   538,  -688,  -688,   539,  -688,   540,   417,  -688,  -688,
     541,   544,   545,   546,   427,   434,   435,   436,   440,   547,
     548,   219,  -688,  -688,    22,  -688,   487,    93,  -688,   488,
      41,  -688,   489,    59,  -688,   493,    42,  -688,    31,  -688,
     -14,  -688,   494,   441,   444,   445,   446,   447,   450,   -33,
    -688,   549,   550,    28,  -688,  -688,  -688,   551,   552,  -688,
     -16,  -688,   499,    34,  -688,   500,   554,  -688,   555,  -688,
     250,   452,   458,   464,  -688,  -688,  -688,  -688,  -688,   466,
     467,  -688,   217,  -688,   553,  -688,   556,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,   224,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,   225,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,   469,   470,  -688,  -688,   476,
     227,  -688,   557,  -688,   477,   561,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
      59,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
     256,  -688,  -688,    82,   561,  -688,  -688,   558,  -688,  -688,
    -688,   228,  -688,  -688,  -688,  -688,  -688,   559,   478,   565,
      82,  -688,   566,  -688,   480,  -688,   563,  -688,  -688,   258,
    -688,   -84,   563,  -688,  -688,   569,   570,   571,   236,  -688,
    -688,  -688,  -688,  -688,  -688,   572,   451,   481,   482,   -84,
    -688,   484,  -688,  -688,  -688,  -688,  -688
  };

  const unsigned short int
  Dhcp4Parser::yydefact_[] =
  {
       0,     2,     4,     6,     8,    10,    12,    14,    16,    18,
      20,    22,    24,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     1,    41,    34,    30,
      29,    26,    27,    28,    33,     3,    31,    32,    54,     5,
      66,     7,   105,     9,   214,    11,   356,    13,   376,    15,
     285,    17,   293,    19,   328,    21,   179,    23,   454,    25,
      43,    37,     0,     0,     0,     0,     0,   378,     0,   295,
     330,     0,     0,    45,     0,    44,     0,     0,    38,    64,
     507,   501,   503,   505,     0,    63,     0,    56,    58,    60,
      61,    62,    59,    98,     0,     0,   395,   114,   116,     0,
       0,     0,     0,   206,   283,   320,   260,   157,   421,   171,
     190,     0,   442,   452,    91,     0,    68,    70,    71,    72,
      73,    88,    89,    76,    77,    78,    79,    83,    84,    74,
      75,    81,    82,    90,    80,    85,    86,    87,   107,   109,
       0,     0,   100,   102,   103,   104,   425,   241,   243,   245,
     348,   366,   239,   247,   249,     0,     0,   253,   251,   368,
     417,   238,   218,   219,   220,   232,     0,   216,   223,   234,
     235,   236,   224,   225,   228,   230,   226,   227,   221,   222,
     237,   229,   233,   231,   364,   363,   361,     0,   358,   360,
     362,   397,   399,   415,   403,   405,   409,   407,   413,   411,
     401,   394,   390,     0,   379,   380,   391,   392,   393,   387,
     382,   388,   384,   385,   386,   389,   383,     0,   310,   147,
       0,   314,   312,   317,     0,   306,   307,     0,   296,   297,
     299,   309,   300,   301,   302,   316,   303,   304,   305,   342,
       0,     0,   340,   341,   344,   345,     0,   331,   332,   334,
     335,   336,   337,   338,   339,   186,   188,   183,     0,   181,
     184,   185,     0,   474,   476,     0,   479,     0,     0,   483,
     487,     0,     0,     0,   492,   499,   472,     0,   456,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,    42,     0,     0,    35,     0,     0,     0,
       0,     0,     0,    53,     0,    55,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    67,     0,
       0,     0,     0,   106,   427,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     215,     0,     0,   357,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   377,     0,   286,     0,     0,     0,
       0,     0,     0,     0,   294,     0,     0,     0,     0,   329,
       0,     0,     0,     0,   180,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     455,    46,    39,     0,     0,     0,     0,     0,     0,    57,
       0,    96,    97,     0,     0,     0,    92,    93,    94,    95,
       0,     0,     0,     0,     0,     0,     0,     0,   441,     0,
       0,    69,     0,     0,   113,   101,   439,   437,   438,   433,
     434,   435,   436,     0,   428,   429,   431,   432,     0,     0,
       0,     0,     0,     0,     0,     0,   258,   259,     0,     0,
       0,     0,   217,     0,   359,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   381,     0,     0,   308,     0,
       0,     0,   319,   298,     0,   346,   347,   333,     0,     0,
     182,   473,     0,     0,   478,     0,   481,   482,     0,     0,
     489,   490,   491,     0,     0,   457,     0,     0,     0,   502,
     504,   506,     0,   396,     0,     0,   208,   287,   322,   262,
       0,     0,   173,     0,     0,     0,    47,   108,   111,   112,
     110,     0,   426,     0,   242,   244,   246,   350,    36,   367,
     240,   248,   250,   255,   256,   257,   254,   252,   370,     0,
     365,   398,   400,   416,   404,   406,   410,   408,   414,   412,
     402,   311,   148,   315,   313,   318,   343,   187,   189,   475,
     477,   480,   485,   486,   484,   488,   494,   495,   496,   497,
     498,   493,   500,    40,     0,   512,     0,   509,   511,     0,
     133,   140,   142,   144,     0,     0,     0,     0,     0,   153,
     155,   132,     0,   118,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,     0,   212,     0,   209,
     210,   291,     0,   288,   289,   326,     0,   323,   324,   266,
       0,   263,   264,   166,   167,   168,   169,   170,     0,   159,
     161,   162,   163,   164,   165,   423,     0,   177,     0,   174,
     175,     0,     0,     0,     0,     0,     0,     0,   192,   194,
     195,   196,   197,   198,   199,   448,   450,     0,   444,   446,
     447,     0,    49,     0,   430,   354,     0,   351,   352,   374,
       0,   371,   372,   419,     0,    65,     0,     0,   508,    99,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   115,   117,     0,   207,     0,   295,   284,     0,
     330,   321,     0,     0,   261,     0,     0,   158,     0,   422,
       0,   172,     0,     0,     0,     0,     0,     0,     0,     0,
     191,     0,     0,     0,   443,   453,    51,     0,    50,   440,
       0,   349,     0,   378,   369,     0,     0,   418,     0,   510,
       0,     0,     0,     0,   146,   149,   150,   151,   152,     0,
       0,   119,     0,   211,     0,   290,     0,   325,   282,   281,
     273,   274,   276,   270,   271,   272,   280,   279,     0,   268,
     275,   277,   278,   265,   160,   424,     0,   176,   200,   201,
     202,   203,   204,   205,   193,     0,     0,   445,    48,     0,
       0,   353,     0,   373,     0,     0,   135,   136,   137,   138,
     139,   134,   141,   143,   145,   154,   156,   213,   292,   327,
       0,   267,   178,   449,   451,    52,   355,   375,   420,   516,
       0,   514,   269,     0,     0,   513,   528,     0,   526,   524,
     520,     0,   518,   522,   523,   521,   515,     0,     0,     0,
       0,   517,     0,   525,     0,   519,     0,   527,   532,     0,
     530,     0,     0,   529,   540,     0,     0,     0,     0,   534,
     536,   537,   538,   539,   531,     0,     0,     0,     0,     0,
     533,     0,   542,   543,   544,   535,   541
  };

  const short int
  Dhcp4Parser::yypgoto_[] =
  {
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,   -49,  -688,    91,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,    89,  -688,  -688,  -688,   -62,
    -688,  -688,  -688,   255,  -688,  -688,  -688,  -688,    70,   251,
     -52,   -47,   -44,  -688,  -688,   -41,  -688,  -688,    67,   252,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,    72,  -119,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,   -69,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -128,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -129,  -688,  -688,
    -688,  -126,   214,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -130,  -688,  -688,  -688,  -688,  -688,  -688,  -687,  -688,  -688,
    -688,  -106,  -688,  -688,  -688,  -103,   254,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -685,  -688,  -688,  -688,  -504,
    -688,  -679,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -111,  -688,  -688,  -215,   562,  -688,  -688,  -688,  -688,  -688,
    -102,  -688,  -688,  -688,  -101,  -688,   240,  -688,   -40,  -688,
    -688,  -688,  -688,  -688,   -39,  -688,  -688,  -688,  -688,  -688,
     -51,  -688,  -688,  -688,  -100,  -688,  -688,  -688,   -94,  -688,
     239,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -133,  -688,  -688,  -688,  -123,   266,  -688,  -688,
     -64,  -688,  -688,  -688,  -688,  -688,  -120,  -688,  -688,  -688,
    -121,  -688,   264,   -45,  -688,  -328,  -688,  -322,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -676,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,    98,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,   -99,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,   108,   241,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,   -50,  -688,  -688,  -688,
    -199,  -688,  -688,  -214,  -688,  -688,  -688,  -688,  -688,  -688,
    -224,  -688,  -688,  -236,  -688,  -688,  -688,  -688,  -688
  };

  const short int
  Dhcp4Parser::yydefgoto_[] =
  {
      -1,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    34,    35,    36,    61,   539,    77,
      78,    37,    60,    74,    75,   527,   672,   737,   738,   114,
      39,    62,    86,    87,    88,   298,    41,    63,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   306,   141,   142,
      43,    64,   143,   329,   144,   330,   530,   145,   124,   310,
     125,   311,   602,   603,   604,   690,   811,   605,   691,   606,
     692,   607,   693,   608,   226,   368,   610,   611,   612,   613,
     614,   699,   615,   700,   126,   320,   638,   639,   640,   641,
     642,   643,   644,   127,   322,   648,   649,   650,   720,    57,
      71,   258,   259,   260,   381,   261,   382,   128,   323,   657,
     658,   659,   660,   661,   662,   663,   664,   129,   316,   618,
     619,   620,   704,    45,    65,   166,   167,   168,   340,   169,
     335,   170,   336,   171,   337,   172,   341,   173,   342,   174,
     346,   175,   345,   546,   176,   177,   130,   319,   630,   631,
     632,   713,   778,   779,   131,   317,    51,    68,   622,   623,
     624,   707,    53,    69,   227,   228,   229,   230,   231,   232,
     233,   367,   234,   371,   235,   370,   236,   237,   372,   238,
     132,   318,   626,   627,   628,   710,    55,    70,   246,   247,
     248,   249,   250,   376,   251,   252,   253,   254,   179,   338,
     676,   677,   678,   740,    47,    66,   187,   188,   189,   351,
     180,   339,   181,   347,   680,   681,   682,   743,    49,    67,
     203,   204,   205,   133,   309,   207,   354,   208,   355,   209,
     363,   210,   357,   211,   358,   212,   360,   213,   359,   214,
     362,   215,   361,   216,   356,   183,   348,   684,   746,   134,
     321,   646,   334,   443,   444,   445,   446,   447,   531,   135,
     136,   325,   667,   668,   669,   731,   670,   732,   137,   326,
      59,    72,   277,   278,   279,   280,   386,   281,   387,   282,
     283,   389,   284,   285,   286,   392,   574,   287,   393,   288,
     289,   290,   291,   397,   581,   292,   398,    89,   300,    90,
     301,    91,   302,    92,   299,   586,   587,   588,   686,   830,
     831,   833,   841,   842,   843,   844,   849,   845,   847,   859,
     860,   861,   868,   869,   870,   875,   871,   872,   873
  };

  const unsigned short int
  Dhcp4Parser::yytable_[] =
  {
      85,   243,   190,   161,   185,   201,   441,   225,   242,   257,
     276,    73,   442,   162,   178,   186,   202,   645,   163,    79,
     182,   164,   206,    27,   165,    28,   774,    29,   775,   146,
     244,   245,   572,   105,   777,   528,   529,   782,   146,   864,
      95,    96,   865,   866,   867,   184,   151,   304,    26,    96,
     191,   192,   305,    96,   191,   192,   651,   652,   653,   654,
     655,   656,    99,   100,   101,   327,   146,   147,   148,   149,
     328,   105,   255,   256,   255,   256,   332,    95,    96,   105,
     219,   333,   150,   105,   151,   152,   153,   154,   155,   156,
     157,   219,   239,   220,   221,   240,   241,   158,   159,    99,
     100,   101,    38,   103,   436,   160,   158,   193,   105,   219,
      40,   194,   195,   196,   197,   198,   199,   218,   200,   633,
     634,   635,   636,   153,   637,   665,   666,   157,    84,    80,
      84,   573,   219,   774,   158,   775,    42,    44,    81,    82,
      83,   777,   160,   219,   782,   220,   221,   349,    46,   222,
     223,   224,   350,    84,    48,   352,   576,   577,   578,   579,
     353,    50,    30,    31,    32,    33,    84,   383,   399,    52,
     327,   687,   384,   400,    84,   685,   688,   332,    84,   701,
      54,    76,   689,   701,   702,    84,    93,   580,   703,    56,
     729,   733,    94,    95,    96,   730,   734,    97,    98,   716,
      58,   104,   717,    84,   836,   441,   837,   838,   399,   776,
     293,   442,   294,   735,   785,    99,   100,   101,   102,   103,
     349,   296,   295,   104,   105,   817,    84,   820,   383,   297,
     352,   850,   821,   822,   106,   826,   851,    84,   718,   879,
     364,   719,    85,   590,   880,   401,   402,   107,   108,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   834,
     109,   862,   835,   110,   863,   438,   543,   544,   545,   219,
     111,   112,   437,   303,   113,   806,   807,   808,   809,   810,
     138,   139,   307,   439,   140,   308,   312,   161,   190,   440,
     185,   313,   314,   315,   324,   331,   343,   162,   178,   344,
     365,   186,   163,   201,   182,   164,   366,   369,   165,   373,
     374,   243,   375,   225,   202,   377,   776,   378,   242,    84,
     206,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   379,   380,   276,   385,   388,
     244,   245,     1,     2,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,   390,   391,   394,   509,   510,   511,
     395,   396,   404,    84,   403,    84,   405,   406,   407,   408,
     410,   413,   414,   415,   420,   421,   411,   412,   416,   417,
     422,   423,   418,   419,   424,   425,   426,   427,   428,   429,
     430,   432,   433,   434,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   458,   459,   460,   457,   461,   463,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   476,
     477,   478,   479,   480,   481,   484,   482,   485,   488,   489,
     486,   491,   492,   493,   495,   498,   499,   503,   494,   496,
     568,   497,   504,   506,   507,   609,   609,   500,   501,   508,
     512,   502,   601,   601,   513,   514,   515,   583,   516,   517,
     518,   519,   520,   276,   438,   521,   522,   532,   534,   523,
     524,   437,   525,   526,   533,   535,   536,   537,   706,   548,
      28,   540,   439,   541,   542,   547,   549,   550,   440,   551,
     552,   554,   555,   556,   617,   621,   625,   557,   558,   559,
     629,   647,   673,   560,   561,   562,   675,   679,   694,   695,
     683,   696,   697,   575,   698,   705,   563,   564,   565,   566,
     708,   709,   567,   569,   712,   711,   714,   715,   570,   721,
     722,   741,   723,   571,   724,   725,   726,   727,   585,   728,
     742,   745,   744,   538,   748,   750,   582,   747,   751,   752,
     753,   759,   760,   795,   796,   799,   553,   798,   804,   409,
     805,   818,   848,   852,   819,   827,   736,   739,   829,   854,
     858,   856,   754,   876,   877,   878,   881,   584,   431,   589,
     756,   755,   761,   757,   435,   758,   788,   616,   784,   789,
     790,   791,   792,   787,   786,   793,   812,   490,   882,   794,
     763,   762,   813,   462,   783,   832,   764,   765,   814,   801,
     815,   816,   767,   823,   824,   483,   766,   800,   464,   487,
     825,   828,   802,   853,   857,   803,   883,   884,   886,   475,
     217,   674,   609,   671,   797,   846,   855,   749,   874,   601,
     505,   243,   161,   885,   773,   225,     0,     0,   242,     0,
       0,   768,   162,   178,     0,     0,     0,   163,   257,   182,
     164,   769,   780,   165,     0,     0,   770,     0,   781,   771,
     244,   245,   772,     0,     0,     0,   190,     0,   185,     0,
       0,   201,     0,     0,     0,     0,     0,     0,     0,   186,
       0,     0,   202,     0,     0,     0,     0,     0,   206,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   773,     0,     0,     0,     0,     0,     0,   768,     0,
       0,     0,     0,     0,   840,     0,     0,     0,   769,   780,
       0,   839,     0,   770,     0,   781,   771,     0,     0,   772,
       0,   840,     0,     0,     0,     0,     0,     0,   839
  };

  const short int
  Dhcp4Parser::yycheck_[] =
  {
      62,    70,    66,    65,    66,    67,   334,    69,    70,    71,
      72,    60,   334,    65,    65,    66,    67,   521,    65,    10,
      65,    65,    67,     5,    65,     7,   713,     9,   713,     7,
      70,    70,    15,    49,   713,    14,    15,   713,     7,   123,
      18,    19,   126,   127,   128,    61,    62,     3,     0,    19,
      20,    21,     8,    19,    20,    21,    89,    90,    91,    92,
      93,    94,    40,    41,    42,     3,     7,    45,    46,    47,
       8,    49,    86,    87,    86,    87,     3,    18,    19,    49,
      50,     8,    60,    49,    62,    63,    64,    65,    66,    67,
      68,    50,    51,    52,    53,    54,    55,    75,    76,    40,
      41,    42,     7,    44,    74,    83,    75,    73,    49,    50,
       7,    77,    78,    79,    80,    81,    82,    24,    84,    77,
      78,    79,    80,    64,    82,    97,    98,    68,   144,   120,
     144,   114,    50,   820,    75,   820,     7,     7,   129,   130,
     131,   820,    83,    50,   820,    52,    53,     3,     7,    56,
      57,    58,     8,   144,     7,     3,   116,   117,   118,   119,
       8,     7,   144,   145,   146,   147,   144,     3,     3,     7,
       3,     3,     8,     8,   144,     8,     8,     3,   144,     3,
       7,   144,     8,     3,     8,   144,    11,   147,     8,     7,
       3,     3,    17,    18,    19,     8,     8,    22,    23,     3,
       7,    48,     6,   144,   122,   533,   124,   125,     3,   713,
       6,   533,     3,     8,   718,    40,    41,    42,    43,    44,
       3,     8,     4,    48,    49,     8,   144,     3,     3,     3,
       3,     3,     8,     8,    59,     8,     8,   144,     3,     3,
       8,     6,   304,    24,     8,   294,   295,    72,    73,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,     3,
      85,     3,     6,    88,     6,   334,    69,    70,    71,    50,
      95,    96,   334,     4,    99,    25,    26,    27,    28,    29,
      12,    13,     4,   334,    16,     4,     4,   349,   352,   334,
     352,     4,     4,     4,     4,     4,     4,   349,   349,     4,
       3,   352,   349,   365,   349,   349,     8,     4,   349,     4,
       8,   380,     3,   375,   365,     4,   820,     4,   380,   144,
     365,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,     8,     3,   399,     4,     4,
     380,   380,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,     4,     4,     4,   406,   407,   408,
       4,     4,     4,   144,   144,   144,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,   147,   147,   145,   145,
       4,     4,   145,   145,     4,     4,     4,     4,   145,     4,
       4,     4,     4,   147,     4,     4,     4,     4,     4,     4,
       4,     4,   145,     4,     4,     4,   147,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,   145,     4,     4,     4,     4,   147,   147,     4,     4,
     147,   147,     4,     4,     4,     4,     4,     4,   145,   145,
     489,   145,     4,     4,     7,   514,   515,   147,   147,     7,
       7,   147,   514,   515,   144,     7,     7,   506,     5,     5,
       5,     5,     5,   525,   533,     5,     5,     8,   144,     7,
       7,   533,     7,     5,     3,   144,   144,     5,     3,     5,
       7,   144,   533,   144,   144,   144,     7,   144,   533,   144,
     144,   144,   144,   144,     7,     7,     7,   144,   144,   144,
       7,     7,     4,   144,   144,   144,     7,     7,     4,     4,
      84,     4,     4,   115,     4,     6,   144,   144,   144,   144,
       6,     3,   144,   144,     3,     6,     6,     3,   144,     6,
       3,     6,     4,   144,     4,     4,     4,     4,   121,     4,
       3,     3,     6,   452,     4,     4,   144,     8,     4,     4,
       4,     4,     4,     4,     4,     3,   467,     6,     4,   304,
       5,     8,     4,     4,     8,     8,   144,   144,     7,     4,
       7,     5,   145,     4,     4,     4,     4,   507,   327,   512,
     145,   147,   701,   147,   332,   145,   145,   515,   716,   145,
     145,   145,   145,   722,   720,   145,   144,   383,   147,   729,
     706,   704,   144,   349,   715,   820,   707,   709,   144,   742,
     144,   144,   712,   144,   144,   375,   710,   740,   352,   380,
     144,   144,   743,   145,   144,   745,   145,   145,   144,   365,
      68,   533,   701,   525,   733,   834,   850,   687,   862,   701,
     399,   710,   704,   879,   713,   707,    -1,    -1,   710,    -1,
      -1,   713,   704,   704,    -1,    -1,    -1,   704,   720,   704,
     704,   713,   713,   704,    -1,    -1,   713,    -1,   713,   713,
     710,   710,   713,    -1,    -1,    -1,   740,    -1,   740,    -1,
      -1,   743,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   740,
      -1,    -1,   743,    -1,    -1,    -1,    -1,    -1,   743,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   820,    -1,    -1,    -1,    -1,    -1,    -1,   820,    -1,
      -1,    -1,    -1,    -1,   833,    -1,    -1,    -1,   820,   820,
      -1,   833,    -1,   820,    -1,   820,   820,    -1,    -1,   820,
      -1,   850,    -1,    -1,    -1,    -1,    -1,    -1,   850
  };

  const unsigned short int
  Dhcp4Parser::yystos_[] =
  {
       0,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,     0,     5,     7,     9,
     144,   145,   146,   147,   162,   163,   164,   169,     7,   178,
       7,   184,     7,   198,     7,   271,     7,   352,     7,   366,
       7,   304,     7,   310,     7,   334,     7,   247,     7,   418,
     170,   165,   179,   185,   199,   272,   353,   367,   305,   311,
     335,   248,   419,   162,   171,   172,   144,   167,   168,    10,
     120,   129,   130,   131,   144,   177,   180,   181,   182,   445,
     447,   449,   451,    11,    17,    18,    19,    22,    23,    40,
      41,    42,    43,    44,    48,    49,    59,    72,    73,    85,
      88,    95,    96,    99,   177,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   206,   208,   232,   241,   255,   265,
     294,   302,   328,   371,   397,   407,   408,   416,    12,    13,
      16,   196,   197,   200,   202,   205,     7,    45,    46,    47,
      60,    62,    63,    64,    65,    66,    67,    68,    75,    76,
      83,   177,   188,   189,   190,   193,   273,   274,   275,   277,
     279,   281,   283,   285,   287,   289,   292,   293,   328,   346,
     358,   360,   371,   393,    61,   177,   328,   354,   355,   356,
     358,    20,    21,    73,    77,    78,    79,    80,    81,    82,
      84,   177,   328,   368,   369,   370,   371,   373,   375,   377,
     379,   381,   383,   385,   387,   389,   391,   302,    24,    50,
      52,    53,    56,    57,    58,   177,   222,   312,   313,   314,
     315,   316,   317,   318,   320,   322,   324,   325,   327,    51,
      54,    55,   177,   222,   316,   322,   336,   337,   338,   339,
     340,   342,   343,   344,   345,    86,    87,   177,   249,   250,
     251,   253,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   177,   420,   421,   422,
     423,   425,   427,   428,   430,   431,   432,   435,   437,   438,
     439,   440,   443,     6,     3,     4,     8,     3,   183,   452,
     446,   448,   450,     4,     3,     8,   195,     4,     4,   372,
     207,   209,     4,     4,     4,     4,   266,   303,   329,   295,
     233,   398,   242,   256,     4,   409,   417,     3,     8,   201,
     203,     4,     3,     8,   400,   278,   280,   282,   347,   359,
     276,   284,   286,     4,     4,   290,   288,   361,   394,     3,
       8,   357,     3,     8,   374,   376,   392,   380,   382,   386,
     384,   390,   388,   378,     8,     3,     8,   319,   223,     4,
     323,   321,   326,     4,     8,     3,   341,     4,     4,     8,
       3,   252,   254,     3,     8,     4,   424,   426,     4,   429,
       4,     4,   433,   436,     4,     4,     4,   441,   444,     3,
       8,   162,   162,   144,     4,     4,     4,     4,     4,   181,
       4,   147,   147,     4,     4,     4,   145,   145,   145,   145,
       4,     4,     4,     4,     4,     4,     4,     4,   145,     4,
       4,   187,     4,     4,   147,   197,    74,   177,   222,   328,
     371,   373,   375,   401,   402,   403,   404,   405,     4,     4,
       4,     4,     4,     4,     4,     4,   145,   147,     4,     4,
       4,     4,   274,     4,   355,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,   370,     4,     4,   145,     4,
       4,     4,   147,   314,     4,   147,   147,   338,     4,     4,
     250,   147,     4,     4,   145,     4,   145,   145,     4,     4,
     147,   147,   147,     4,     4,   421,     4,     7,     7,   162,
     162,   162,     7,   144,     7,     7,     5,     5,     5,     5,
       5,     5,     5,     7,     7,     7,     5,   173,    14,    15,
     204,   406,     8,     3,   144,   144,   144,     5,   164,   166,
     144,   144,   144,    69,    70,    71,   291,   144,     5,     7,
     144,   144,   144,   173,   144,   144,   144,   144,   144,   144,
     144,   144,   144,   144,   144,   144,   144,   144,   162,   144,
     144,   144,    15,   114,   434,   115,   116,   117,   118,   119,
     147,   442,   144,   162,   186,   121,   453,   454,   455,   196,
      24,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,   177,   210,   211,   212,   215,   217,   219,   221,   222,
     224,   225,   226,   227,   228,   230,   210,     7,   267,   268,
     269,     7,   306,   307,   308,     7,   330,   331,   332,     7,
     296,   297,   298,    77,    78,    79,    80,    82,   234,   235,
     236,   237,   238,   239,   240,   287,   399,     7,   243,   244,
     245,    89,    90,    91,    92,    93,    94,   257,   258,   259,
     260,   261,   262,   263,   264,    97,    98,   410,   411,   412,
     414,   420,   174,     4,   403,     7,   348,   349,   350,     7,
     362,   363,   364,    84,   395,     8,   456,     3,     8,     8,
     213,   216,   218,   220,     4,     4,     4,     4,     4,   229,
     231,     3,     8,     8,   270,     6,     3,   309,     6,     3,
     333,     6,     3,   299,     6,     3,     3,     6,     3,     6,
     246,     6,     3,     4,     4,     4,     4,     4,     4,     3,
       8,   413,   415,     3,     8,     8,   144,   175,   176,   144,
     351,     6,     3,   365,     6,     3,   396,     8,     4,   454,
       4,     4,     4,     4,   145,   147,   145,   147,   145,     4,
       4,   211,   273,   269,   312,   308,   336,   332,   177,   188,
     189,   190,   193,   222,   265,   283,   287,   289,   300,   301,
     328,   371,   393,   298,   235,   287,   249,   245,   145,   145,
     145,   145,   145,   145,   258,     4,     4,   411,     6,     3,
     354,   350,   368,   364,     4,     5,    25,    26,    27,    28,
      29,   214,   144,   144,   144,   144,   144,     8,     8,     8,
       3,     8,     8,   144,   144,   144,     8,     8,   144,     7,
     457,   458,   301,   459,     3,     6,   122,   124,   125,   177,
     222,   460,   461,   462,   463,   465,   458,   466,     4,   464,
       3,     8,     4,   145,     4,   461,     5,   144,     7,   467,
     468,   469,     3,     6,   123,   126,   127,   128,   470,   471,
     472,   474,   475,   476,   468,   473,     4,     4,     4,     3,
       8,     4,   147,   145,   145,   471,   144
  };

  const unsigned short int
  Dhcp4Parser::yyr1_[] =
  {
       0,   148,   150,   149,   151,   149,   152,   149,   153,   149,
     154,   149,   155,   149,   156,   149,   157,   149,   158,   149,
     159,   149,   160,   149,   161,   149,   162,   162,   162,   162,
     162,   162,   162,   163,   165,   164,   166,   167,   167,   168,
     168,   170,   169,   171,   171,   172,   172,   174,   173,   175,
     175,   176,   176,   177,   179,   178,   180,   180,   181,   181,
     181,   181,   181,   181,   183,   182,   185,   184,   186,   186,
     187,   187,   187,   187,   187,   187,   187,   187,   187,   187,
     187,   187,   187,   187,   187,   187,   187,   187,   187,   187,
     187,   187,   188,   189,   190,   191,   192,   193,   195,   194,
     196,   196,   197,   197,   197,   199,   198,   201,   200,   203,
     202,   204,   204,   205,   207,   206,   209,   208,   210,   210,
     211,   211,   211,   211,   211,   211,   211,   211,   211,   211,
     211,   211,   211,   213,   212,   214,   214,   214,   214,   214,
     216,   215,   218,   217,   220,   219,   221,   223,   222,   224,
     225,   226,   227,   229,   228,   231,   230,   233,   232,   234,
     234,   235,   235,   235,   235,   235,   236,   237,   238,   239,
     240,   242,   241,   243,   243,   244,   244,   246,   245,   248,
     247,   249,   249,   249,   250,   250,   252,   251,   254,   253,
     256,   255,   257,   257,   258,   258,   258,   258,   258,   258,
     259,   260,   261,   262,   263,   264,   266,   265,   267,   267,
     268,   268,   270,   269,   272,   271,   273,   273,   274,   274,
     274,   274,   274,   274,   274,   274,   274,   274,   274,   274,
     274,   274,   274,   274,   274,   274,   274,   274,   274,   276,
     275,   278,   277,   280,   279,   282,   281,   284,   283,   286,
     285,   288,   287,   290,   289,   291,   291,   291,   292,   293,
     295,   294,   296,   296,   297,   297,   299,   298,   300,   300,
     301,   301,   301,   301,   301,   301,   301,   301,   301,   301,
     301,   301,   301,   303,   302,   305,   304,   306,   306,   307,
     307,   309,   308,   311,   310,   312,   312,   313,   313,   314,
     314,   314,   314,   314,   314,   314,   314,   315,   316,   317,
     319,   318,   321,   320,   323,   322,   324,   326,   325,   327,
     329,   328,   330,   330,   331,   331,   333,   332,   335,   334,
     336,   336,   337,   337,   338,   338,   338,   338,   338,   338,
     338,   339,   341,   340,   342,   343,   344,   345,   347,   346,
     348,   348,   349,   349,   351,   350,   353,   352,   354,   354,
     355,   355,   355,   355,   357,   356,   359,   358,   361,   360,
     362,   362,   363,   363,   365,   364,   367,   366,   368,   368,
     369,   369,   370,   370,   370,   370,   370,   370,   370,   370,
     370,   370,   370,   370,   370,   372,   371,   374,   373,   376,
     375,   378,   377,   380,   379,   382,   381,   384,   383,   386,
     385,   388,   387,   390,   389,   392,   391,   394,   393,   396,
     395,   398,   397,   399,   399,   400,   287,   401,   401,   402,
     402,   403,   403,   403,   403,   403,   403,   403,   404,   406,
     405,   407,   409,   408,   410,   410,   411,   411,   413,   412,
     415,   414,   417,   416,   419,   418,   420,   420,   421,   421,
     421,   421,   421,   421,   421,   421,   421,   421,   421,   421,
     421,   421,   421,   422,   424,   423,   426,   425,   427,   429,
     428,   430,   431,   433,   432,   434,   434,   436,   435,   437,
     438,   439,   441,   440,   442,   442,   442,   442,   442,   444,
     443,   446,   445,   448,   447,   450,   449,   452,   451,   453,
     453,   454,   456,   455,   457,   457,   459,   458,   460,   460,
     461,   461,   461,   461,   461,   462,   464,   463,   466,   465,
     467,   467,   469,   468,   470,   470,   471,   471,   471,   471,
     473,   472,   474,   475,   476
  };

  const unsigned char
  Dhcp4Parser::yyr2_[] =
  {
       0,     2,     0,     3,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     0,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     4,     1,     0,     1,     3,
       5,     0,     4,     0,     1,     1,     3,     0,     4,     0,
       1,     1,     3,     2,     0,     4,     1,     3,     1,     1,
       1,     1,     1,     1,     0,     6,     0,     4,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     3,     0,     6,
       1,     3,     1,     1,     1,     0,     4,     0,     4,     0,
       4,     1,     1,     3,     0,     6,     0,     6,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     4,     1,     1,     1,     1,     1,
       0,     4,     0,     4,     0,     4,     3,     0,     4,     3,
       3,     3,     3,     0,     4,     0,     4,     0,     6,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     6,     0,     1,     1,     3,     0,     4,     0,
       4,     1,     3,     1,     1,     1,     0,     4,     0,     4,
       0,     6,     1,     3,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     0,     6,     0,     1,
       1,     3,     0,     4,     0,     4,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     4,     0,
       4,     0,     4,     0,     4,     1,     1,     1,     3,     3,
       0,     6,     0,     1,     1,     3,     0,     4,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     6,     0,     4,     0,     1,     1,
       3,     0,     4,     0,     4,     0,     1,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       0,     4,     0,     4,     0,     4,     1,     0,     4,     3,
       0,     6,     0,     1,     1,     3,     0,     4,     0,     4,
       0,     1,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     4,     1,     1,     3,     3,     0,     6,
       0,     1,     1,     3,     0,     4,     0,     4,     1,     3,
       1,     1,     1,     1,     0,     4,     0,     4,     0,     6,
       0,     1,     1,     3,     0,     4,     0,     4,     0,     1,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     4,     0,     4,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     4,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     6,     0,
       4,     0,     6,     1,     3,     0,     4,     0,     1,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       4,     3,     0,     6,     1,     3,     1,     1,     0,     4,
       0,     4,     0,     6,     0,     4,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     0,     4,     0,     4,     3,     0,
       4,     3,     3,     0,     4,     1,     1,     0,     4,     3,
       3,     3,     0,     4,     1,     1,     1,     1,     1,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     6,     1,
       3,     1,     0,     6,     1,     3,     0,     4,     1,     3,
       1,     1,     1,     1,     1,     3,     0,     4,     0,     6,
       1,     3,     0,     4,     1,     3,     1,     1,     1,     1,
       0,     4,     3,     3,     3
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const Dhcp4Parser::yytname_[] =
  {
  "\"end of file\"", "error", "$undefined", "\",\"", "\":\"", "\"[\"",
  "\"]\"", "\"{\"", "\"}\"", "\"null\"", "\"Dhcp4\"",
  "\"interfaces-config\"", "\"interfaces\"", "\"dhcp-socket-type\"",
  "\"raw\"", "\"udp\"", "\"re-detect\"", "\"echo-client-id\"",
  "\"match-client-id\"", "\"next-server\"", "\"server-hostname\"",
  "\"boot-file-name\"", "\"lease-database\"", "\"hosts-database\"",
  "\"type\"", "\"memfile\"", "\"mysql\"", "\"postgresql\"", "\"cql\"",
  "\"radius\"", "\"user\"", "\"password\"", "\"host\"", "\"port\"",
  "\"persist\"", "\"lfc-interval\"", "\"readonly\"", "\"connect-timeout\"",
  "\"contact-points\"", "\"keyspace\"", "\"valid-lifetime\"",
  "\"renew-timer\"", "\"rebind-timer\"", "\"decline-probation-period\"",
  "\"subnet4\"", "\"4o6-interface\"", "\"4o6-interface-id\"",
  "\"4o6-subnet\"", "\"option-def\"", "\"option-data\"", "\"name\"",
  "\"data\"", "\"code\"", "\"space\"", "\"csv-format\"", "\"always-send\"",
  "\"record-types\"", "\"encapsulate\"", "\"array\"",
  "\"shared-networks\"", "\"pools\"", "\"pool\"", "\"user-context\"",
  "\"subnet\"", "\"interface\"", "\"interface-id\"", "\"id\"",
  "\"rapid-commit\"", "\"reservation-mode\"", "\"disabled\"",
  "\"out-of-pool\"", "\"all\"", "\"host-reservation-identifiers\"",
  "\"client-classes\"", "\"test\"", "\"client-class\"", "\"reservations\"",
  "\"duid\"", "\"hw-address\"", "\"circuit-id\"", "\"client-id\"",
  "\"hostname\"", "\"flex-id\"", "\"relay\"", "\"ip-address\"",
  "\"hooks-libraries\"", "\"library\"", "\"parameters\"",
  "\"expired-leases-processing\"", "\"reclaim-timer-wait-time\"",
  "\"flush-reclaimed-timer-wait-time\"", "\"hold-reclaimed-time\"",
  "\"max-reclaim-leases\"", "\"max-reclaim-time\"",
  "\"unwarned-reclaim-cycles\"", "\"dhcp4o6-port\"", "\"control-socket\"",
  "\"socket-type\"", "\"socket-name\"", "\"dhcp-ddns\"",
  "\"enable-updates\"", "\"qualifying-suffix\"", "\"server-ip\"",
  "\"server-port\"", "\"sender-ip\"", "\"sender-port\"",
  "\"max-queue-size\"", "\"ncr-protocol\"", "\"ncr-format\"",
  "\"always-include-fqdn\"", "\"override-no-update\"",
  "\"override-client-update\"", "\"replace-client-name\"",
  "\"generated-prefix\"", "\"tcp\"", "\"JSON\"", "\"when-present\"",
  "\"never\"", "\"always\"", "\"when-not-present\"", "\"Logging\"",
  "\"loggers\"", "\"output_options\"", "\"output\"", "\"debuglevel\"",
  "\"severity\"", "\"flush\"", "\"maxsize\"", "\"maxver\"", "\"Dhcp6\"",
  "\"DhcpDdns\"", "\"Control-agent\"", "TOPLEVEL_JSON", "TOPLEVEL_DHCP4",
  "SUB_DHCP4", "SUB_INTERFACES4", "SUB_SUBNET4", "SUB_POOL4",
  "SUB_RESERVATION", "SUB_OPTION_DEFS", "SUB_OPTION_DEF",
  "SUB_OPTION_DATA", "SUB_HOOKS_LIBRARY", "SUB_DHCP_DDNS",
  "\"constant string\"", "\"integer\"", "\"floating point\"",
  "\"boolean\"", "$accept", "start", "$@1", "$@2", "$@3", "$@4", "$@5",
  "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "value", "sub_json",
  "map2", "$@13", "map_value", "map_content", "not_empty_map",
  "list_generic", "$@14", "list_content", "not_empty_list", "list_strings",
  "$@15", "list_strings_content", "not_empty_list_strings",
  "unknown_map_entry", "syntax_map", "$@16", "global_objects",
  "global_object", "dhcp4_object", "$@17", "sub_dhcp4", "$@18",
  "global_params", "global_param", "valid_lifetime", "renew_timer",
  "rebind_timer", "decline_probation_period", "echo_client_id",
  "match_client_id", "interfaces_config", "$@19",
  "interfaces_config_params", "interfaces_config_param", "sub_interfaces4",
  "$@20", "interfaces_list", "$@21", "dhcp_socket_type", "$@22",
  "socket_type", "re_detect", "lease_database", "$@23", "hosts_database",
  "$@24", "database_map_params", "database_map_param", "database_type",
  "$@25", "db_type", "user", "$@26", "password", "$@27", "host", "$@28",
  "port", "name", "$@29", "persist", "lfc_interval", "readonly",
  "connect_timeout", "contact_points", "$@30", "keyspace", "$@31",
  "host_reservation_identifiers", "$@32",
  "host_reservation_identifiers_list", "host_reservation_identifier",
  "duid_id", "hw_address_id", "circuit_id", "client_id", "flex_id",
  "hooks_libraries", "$@33", "hooks_libraries_list",
  "not_empty_hooks_libraries_list", "hooks_library", "$@34",
  "sub_hooks_library", "$@35", "hooks_params", "hooks_param", "library",
  "$@36", "parameters", "$@37", "expired_leases_processing", "$@38",
  "expired_leases_params", "expired_leases_param",
  "reclaim_timer_wait_time", "flush_reclaimed_timer_wait_time",
  "hold_reclaimed_time", "max_reclaim_leases", "max_reclaim_time",
  "unwarned_reclaim_cycles", "subnet4_list", "$@39",
  "subnet4_list_content", "not_empty_subnet4_list", "subnet4", "$@40",
  "sub_subnet4", "$@41", "subnet4_params", "subnet4_param", "subnet",
  "$@42", "subnet_4o6_interface", "$@43", "subnet_4o6_interface_id",
  "$@44", "subnet_4o6_subnet", "$@45", "interface", "$@46", "interface_id",
  "$@47", "client_class", "$@48", "reservation_mode", "$@49", "hr_mode",
  "id", "rapid_commit", "shared_networks", "$@50",
  "shared_networks_content", "shared_networks_list", "shared_network",
  "$@51", "shared_network_params", "shared_network_param",
  "option_def_list", "$@52", "sub_option_def_list", "$@53",
  "option_def_list_content", "not_empty_option_def_list",
  "option_def_entry", "$@54", "sub_option_def", "$@55",
  "option_def_params", "not_empty_option_def_params", "option_def_param",
  "option_def_name", "code", "option_def_code", "option_def_type", "$@56",
  "option_def_record_types", "$@57", "space", "$@58", "option_def_space",
  "option_def_encapsulate", "$@59", "option_def_array", "option_data_list",
  "$@60", "option_data_list_content", "not_empty_option_data_list",
  "option_data_entry", "$@61", "sub_option_data", "$@62",
  "option_data_params", "not_empty_option_data_params",
  "option_data_param", "option_data_name", "option_data_data", "$@63",
  "option_data_code", "option_data_space", "option_data_csv_format",
  "option_data_always_send", "pools_list", "$@64", "pools_list_content",
  "not_empty_pools_list", "pool_list_entry", "$@65", "sub_pool4", "$@66",
  "pool_params", "pool_param", "pool_entry", "$@67", "user_context",
  "$@68", "reservations", "$@69", "reservations_list",
  "not_empty_reservations_list", "reservation", "$@70", "sub_reservation",
  "$@71", "reservation_params", "not_empty_reservation_params",
  "reservation_param", "next_server", "$@72", "server_hostname", "$@73",
  "boot_file_name", "$@74", "ip_address", "$@75", "duid", "$@76",
  "hw_address", "$@77", "client_id_value", "$@78", "circuit_id_value",
  "$@79", "flex_id_value", "$@80", "hostname", "$@81",
  "reservation_client_classes", "$@82", "relay", "$@83", "relay_map",
  "$@84", "client_classes", "$@85", "client_classes_list", "$@86",
  "client_class_params", "not_empty_client_class_params",
  "client_class_param", "client_class_name", "client_class_test", "$@87",
  "dhcp4o6_port", "control_socket", "$@88", "control_socket_params",
  "control_socket_param", "control_socket_type", "$@89",
  "control_socket_name", "$@90", "dhcp_ddns", "$@91", "sub_dhcp_ddns",
  "$@92", "dhcp_ddns_params", "dhcp_ddns_param", "enable_updates",
  "qualifying_suffix", "$@93", "server_ip", "$@94", "server_port",
  "sender_ip", "$@95", "sender_port", "max_queue_size", "ncr_protocol",
  "$@96", "ncr_protocol_value", "ncr_format", "$@97",
  "always_include_fqdn", "override_no_update", "override_client_update",
  "replace_client_name", "$@98", "replace_client_name_value",
  "generated_prefix", "$@99", "dhcp6_json_object", "$@100",
  "dhcpddns_json_object", "$@101", "control_agent_json_object", "$@102",
  "logging_object", "$@103", "logging_params", "logging_param", "loggers",
  "$@104", "loggers_entries", "logger_entry", "$@105", "logger_params",
  "logger_param", "debuglevel", "severity", "$@106", "output_options_list",
  "$@107", "output_options_list_content", "output_entry", "$@108",
  "output_params_list", "output_params", "output", "$@109", "flush",
  "maxsize", "maxver", YY_NULLPTR
  };

#if PARSER4_DEBUG
  const unsigned short int
  Dhcp4Parser::yyrline_[] =
  {
       0,   230,   230,   230,   231,   231,   232,   232,   233,   233,
     234,   234,   235,   235,   236,   236,   237,   237,   238,   238,
     239,   239,   240,   240,   241,   241,   249,   250,   251,   252,
     253,   254,   255,   258,   263,   263,   274,   277,   278,   281,
     285,   292,   292,   299,   300,   303,   307,   314,   314,   321,
     322,   325,   329,   340,   350,   350,   366,   367,   371,   372,
     373,   374,   375,   376,   379,   379,   394,   394,   403,   404,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   433,   438,   443,   448,   453,   458,   464,   464,
     475,   476,   479,   480,   481,   484,   484,   493,   493,   503,
     503,   510,   511,   514,   520,   520,   532,   532,   544,   545,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   563,   563,   570,   571,   572,   573,   574,
     577,   577,   585,   585,   593,   593,   601,   606,   606,   614,
     619,   624,   629,   634,   634,   642,   642,   651,   651,   661,
     662,   665,   666,   667,   668,   669,   672,   677,   682,   687,
     692,   697,   697,   707,   708,   711,   712,   715,   715,   725,
     725,   735,   736,   737,   740,   741,   744,   744,   752,   752,
     760,   760,   771,   772,   775,   776,   777,   778,   779,   780,
     783,   788,   793,   798,   803,   808,   816,   816,   829,   830,
     833,   834,   841,   841,   867,   867,   878,   879,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,   906,
     906,   914,   914,   922,   922,   930,   930,   938,   938,   946,
     946,   954,   954,   962,   962,   969,   970,   971,   974,   979,
     986,   986,   997,   998,  1002,  1003,  1006,  1006,  1014,  1015,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1037,  1037,  1050,  1050,  1059,  1060,  1063,
    1064,  1069,  1069,  1084,  1084,  1098,  1099,  1102,  1103,  1106,
    1107,  1108,  1109,  1110,  1111,  1112,  1113,  1116,  1118,  1123,
    1125,  1125,  1133,  1133,  1141,  1141,  1149,  1151,  1151,  1159,
    1168,  1168,  1180,  1181,  1186,  1187,  1192,  1192,  1204,  1204,
    1216,  1217,  1222,  1223,  1228,  1229,  1230,  1231,  1232,  1233,
    1234,  1237,  1239,  1239,  1247,  1249,  1251,  1256,  1264,  1264,
    1276,  1277,  1280,  1281,  1284,  1284,  1294,  1294,  1304,  1305,
    1308,  1309,  1310,  1311,  1314,  1314,  1322,  1322,  1332,  1332,
    1342,  1343,  1346,  1347,  1350,  1350,  1359,  1359,  1368,  1369,
    1372,  1373,  1377,  1378,  1379,  1380,  1381,  1382,  1383,  1384,
    1385,  1386,  1387,  1388,  1389,  1392,  1392,  1400,  1400,  1408,
    1408,  1416,  1416,  1424,  1424,  1432,  1432,  1440,  1440,  1448,
    1448,  1456,  1456,  1464,  1464,  1472,  1472,  1485,  1485,  1495,
    1495,  1506,  1506,  1516,  1517,  1520,  1520,  1530,  1531,  1534,
    1535,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1547,  1549,
    1549,  1561,  1568,  1568,  1578,  1579,  1582,  1583,  1586,  1586,
    1594,  1594,  1604,  1604,  1616,  1616,  1626,  1627,  1630,  1631,
    1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1647,  1652,  1652,  1660,  1660,  1668,  1673,
    1673,  1681,  1686,  1691,  1691,  1699,  1700,  1703,  1703,  1711,
    1716,  1721,  1726,  1726,  1734,  1737,  1740,  1743,  1746,  1752,
    1752,  1762,  1762,  1769,  1769,  1776,  1776,  1788,  1788,  1801,
    1802,  1806,  1810,  1810,  1822,  1823,  1827,  1827,  1835,  1836,
    1839,  1840,  1841,  1842,  1843,  1846,  1851,  1851,  1859,  1859,
    1869,  1870,  1873,  1873,  1881,  1882,  1885,  1886,  1887,  1888,
    1891,  1891,  1899,  1904,  1909
  };

  // Print the state stack on the debug stream.
  void
  Dhcp4Parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  Dhcp4Parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // PARSER4_DEBUG


#line 14 "dhcp4_parser.yy" // lalr1.cc:1167
} } // isc::dhcp
#line 4326 "dhcp4_parser.cc" // lalr1.cc:1167
#line 1914 "dhcp4_parser.yy" // lalr1.cc:1168


void
isc::dhcp::Dhcp4Parser::error(const location_type& loc,
                              const std::string& what)
{
    ctx.error(loc, what);
}
